#!/usr/bin/perl -w

# Copyright CREX:
# Script sous licence GPL
# TransPerl v0.2

# Depuis la 0.1: changement du filtre de dsentrelacement de smartyuv vers smartdeinter (meilleure qualite 
#  visuelle, mais dtriore le temps de compression). Au besoin, je peux rajouter une option pour choisir 
#  le type de filtre.

use Getopt::Long;

# Hauteur et largeur en pixels du dvd
our $max_largeur;
our $max_hauteur;


GetOptions("projet=s" => \$projet,
	   "help" => \$help,
	   "desentrelace" => \$desentrelace);

if ($help){
print "Vous avez demand de l'aide?\nPour utiliser ce script lancez-le avec en paramtre le nom du projet. ex:\n./transperl.pl --projet TWO_WEEKS_NOTICE\n";
exit (1);
}

######## dsentrelacement
if ($desentrelace){
  $deint = "-J smartdeinter=threshold=10:Blend=1:diffmode=2:highq=1"
} else {
  $deint ='';
}

######### Lecture du fichier de config de tuxrip #############################
open(CONFIG, "$ENV{HOME}/.tuxriprc")
  or die "ERREUR: fichier de config de tuxrip inexistant";
my $racine;              # rpertoire racine des projets de rip
while (<CONFIG>){
  chomp;                 # grignotte les retours  la ligne
  if ($_ =~ m/^1\. */) { # on identifie la ligne commenant par "1. " du fichier de config
    $racine = $';        # $' matche la sous-chaine suivant la regex
  }
}

print "Ton fichier de config est: $racine \n";

######### Lecture du fichier de log du dvd #############################
open(DVD, "$racine/$projet/tmp/infos.dvd")
  or die "ERREUR: fichier log du dvd inexistant";
while (<DVD>){
  chomp;                 # grignotte les retours  la ligne
  if ($_ =~ m/^VIDEO:  MPEG2  */) {
	my ($dimensions, $rubbish) = split /  /,$',2;
	print "les dimensions du dvd sont:$dimensions\n";
	($max_largeur,$max_hauteur,$rubbish) = split /x/,$dimensions,3;
  }
}



######### Lecture du fichier de log du projet ################################
open (LOG_PROJET, "$racine/$projet/tmp/log")
  or die "Pas de fichier de log pour votre projet: assurez-vous d'avoir cr un projet avec tuxrip et d'tre arriv au moins  l'tape n5";

my ($crop_transcode, $scale_transcode, $bitrate_transcode);

while (<LOG_PROJET>){
  chomp;

  ####### Traitement des paramtres Cropping #############################
  if ($_ =~ m/^cropping --> */ ){
    my ($crop_mencoder, $h,$l) = split / /,$',3;
    
    my ($largeur,$hauteur,$crop_gauche,$crop_haut) = split /:/, $crop_mencoder,4;
    ##### "Normalisation" du crop pour pouvoir utiliser le "fast resize"
    $largeur = $largeur - ($largeur%8);
    $hauteur = $hauteur - ($hauteur%8);
    my $crop_bas=$max_hauteur-$hauteur-$crop_haut;
    my $crop_droite=$max_largeur-$largeur-$crop_gauche;
    
    $crop_transcode = "$crop_haut,$crop_gauche,$crop_bas,$crop_droite";
    
    print "le crop trancode est: $crop_transcode\n";
  }
  
  ####### Traitement des paramtres Scale, Bitrate #######################
  if ($_ =~ m/^taille vise, rsolution, bitrate --> */ ){
    my ($taille_visee, $resolution, $bitrate) = split / /,$',3;
    $bitrate_transcode = $bitrate;
    my ($X, $Y) =  split /:/, $resolution,2;
    $scale_transcode = "$X"."x$Y";
    print "le scale transcode est: $scale_transcode\n";
  }
}

my $commande_base = "transcode --nice 20 -i $racine/$projet/vob/$projet.vob -x vob,null -y xvid4,null -V $deint -j $crop_transcode -Z $scale_transcode,fast -w $bitrate_transcode";
my $commande_trancode = "$commande_base -o /dev/null -R 1&&$commande_base -o $racine/$projet/video/${projet}sans-son.avi -R 2";
print "Je vais lancer l'encodage avec cette commande:\n$commande_trancode\n";
chdir "$racine/$projet/tmp";
system "$commande_trancode";
